/* application-configuration.c generated by valac 0.56.18, the Vala compiler
 * generated from application-configuration.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include "geary-engine.h"

#define APPLICATION_CONFIGURATION_CLOCK_FORMAT_KEY "clock-format"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	APPLICATION_CONFIGURATION_0_PROPERTY,
	APPLICATION_CONFIGURATION_SETTINGS_PROPERTY,
	APPLICATION_CONFIGURATION_GNOME_INTERFACE_PROPERTY,
	APPLICATION_CONFIGURATION_ENABLE_DEBUG_PROPERTY,
	APPLICATION_CONFIGURATION_ENABLE_INSPECTOR_PROPERTY,
	APPLICATION_CONFIGURATION_REVOKE_CERTS_PROPERTY,
	APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_PROPERTY,
	APPLICATION_CONFIGURATION_WINDOW_WIDTH_PROPERTY,
	APPLICATION_CONFIGURATION_WINDOW_HEIGHT_PROPERTY,
	APPLICATION_CONFIGURATION_WINDOW_MAXIMIZE_PROPERTY,
	APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE_PROPERTY,
	APPLICATION_CONFIGURATION_AUTOSELECT_PROPERTY,
	APPLICATION_CONFIGURATION_DISPLAY_PREVIEW_PROPERTY,
	APPLICATION_CONFIGURATION_UNSET_HTML_COLORS_PROPERTY,
	APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS_PROPERTY,
	APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_PROPERTY,
	APPLICATION_CONFIGURATION_CLOCK_FORMAT_PROPERTY,
	APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_PROPERTY,
	APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_PROPERTY,
	APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_PROPERTY,
	APPLICATION_CONFIGURATION_UNDO_SEND_DELAY_PROPERTY,
	APPLICATION_CONFIGURATION_BRIEF_NOTIFICATION_DURATION_PROPERTY,
	APPLICATION_CONFIGURATION_NUM_PROPERTIES
};
static GParamSpec* application_configuration_properties[APPLICATION_CONFIGURATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ApplicationConfigurationPrivate {
	GSettings* _settings;
	GSettings* _gnome_interface;
	gboolean _enable_debug;
	gboolean _enable_inspector;
	gboolean _revoke_certs;
	gboolean _single_key_shortcuts;
};

static gint ApplicationConfiguration_private_offset;
static gpointer application_configuration_parent_class = NULL;

static void application_configuration_set_settings (ApplicationConfiguration* self,
                                             GSettings* value);
static void application_configuration_set_gnome_interface (ApplicationConfiguration* self,
                                                    GSettings* value);
static void application_configuration_set_boolean (ApplicationConfiguration* self,
                                            const gchar* name,
                                            gboolean value);
static gint _variant_get1 (GVariant* value);
static gint _variant_get2 (GVariant* value);
static GVariant* _variant_new1 (gint* value,
                         gint value_length1);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static void application_configuration_finalize (GObject * obj);
static GType application_configuration_get_type_once (void);
static void _vala_application_configuration_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_application_configuration_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
application_configuration_get_instance_private (ApplicationConfiguration* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationConfiguration_private_offset);
}

static GType
application_configuration_desktop_environment_get_type_once (void)
{
	static const GEnumValue values[] = {{APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN, "APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN", "unknown"}, {APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY, "APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY", "unity"}, {0, NULL, NULL}};
	GType application_configuration_desktop_environment_type_id;
	application_configuration_desktop_environment_type_id = g_enum_register_static ("ApplicationConfigurationDesktopEnvironment", values);
	return application_configuration_desktop_environment_type_id;
}

GType
application_configuration_desktop_environment_get_type (void)
{
	static volatile gsize application_configuration_desktop_environment_type_id__once = 0;
	if (g_once_init_enter (&application_configuration_desktop_environment_type_id__once)) {
		GType application_configuration_desktop_environment_type_id;
		application_configuration_desktop_environment_type_id = application_configuration_desktop_environment_get_type_once ();
		g_once_init_leave (&application_configuration_desktop_environment_type_id__once, application_configuration_desktop_environment_type_id);
	}
	return application_configuration_desktop_environment_type_id__once;
}

void
application_configuration_init (gboolean is_installed,
                                const gchar* schema_dir)
{
#line 46 "../src/client/application/application-configuration.vala"
	if (!is_installed) {
#line 47 "../src/client/application/application-configuration.vala"
		_vala_assert (schema_dir != NULL, "schema_dir != null");
#line 50 "../src/client/application/application-configuration.vala"
		g_setenv ("GSETTINGS_SCHEMA_DIR", schema_dir, TRUE);
#line 153 "application-configuration.c"
	}
}

GSettings*
application_configuration_get_settings (ApplicationConfiguration* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 55 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), NULL);
#line 55 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 55 "../src/client/application/application-configuration.vala"
	result = _tmp0_;
#line 55 "../src/client/application/application-configuration.vala"
	return result;
#line 170 "application-configuration.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/client/application/application-configuration.vala"
	return self ? g_object_ref (self) : NULL;
#line 178 "application-configuration.c"
}

static void
application_configuration_set_settings (ApplicationConfiguration* self,
                                        GSettings* value)
{
	GSettings* old_value;
#line 55 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 55 "../src/client/application/application-configuration.vala"
	old_value = application_configuration_get_settings (self);
#line 55 "../src/client/application/application-configuration.vala"
	if (old_value != value) {
#line 192 "application-configuration.c"
		GSettings* _tmp0_;
#line 55 "../src/client/application/application-configuration.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 55 "../src/client/application/application-configuration.vala"
		_g_object_unref0 (self->priv->_settings);
#line 55 "../src/client/application/application-configuration.vala"
		self->priv->_settings = _tmp0_;
#line 55 "../src/client/application/application-configuration.vala"
		g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_SETTINGS_PROPERTY]);
#line 202 "application-configuration.c"
	}
}

GSettings*
application_configuration_get_gnome_interface (ApplicationConfiguration* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 56 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), NULL);
#line 56 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_gnome_interface;
#line 56 "../src/client/application/application-configuration.vala"
	result = _tmp0_;
#line 56 "../src/client/application/application-configuration.vala"
	return result;
#line 219 "application-configuration.c"
}

static void
application_configuration_set_gnome_interface (ApplicationConfiguration* self,
                                               GSettings* value)
{
	GSettings* old_value;
#line 56 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 56 "../src/client/application/application-configuration.vala"
	old_value = application_configuration_get_gnome_interface (self);
#line 56 "../src/client/application/application-configuration.vala"
	if (old_value != value) {
#line 233 "application-configuration.c"
		GSettings* _tmp0_;
#line 56 "../src/client/application/application-configuration.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../src/client/application/application-configuration.vala"
		_g_object_unref0 (self->priv->_gnome_interface);
#line 56 "../src/client/application/application-configuration.vala"
		self->priv->_gnome_interface = _tmp0_;
#line 56 "../src/client/application/application-configuration.vala"
		g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_GNOME_INTERFACE_PROPERTY]);
#line 243 "application-configuration.c"
	}
}

gboolean
application_configuration_get_enable_debug (ApplicationConfiguration* self)
{
	gboolean result;
#line 59 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 59 "../src/client/application/application-configuration.vala"
	result = self->priv->_enable_debug;
#line 59 "../src/client/application/application-configuration.vala"
	return result;
#line 257 "application-configuration.c"
}

void
application_configuration_set_enable_debug (ApplicationConfiguration* self,
                                            gboolean value)
{
	gboolean old_value;
#line 59 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 59 "../src/client/application/application-configuration.vala"
	old_value = application_configuration_get_enable_debug (self);
#line 59 "../src/client/application/application-configuration.vala"
	if (old_value != value) {
#line 59 "../src/client/application/application-configuration.vala"
		self->priv->_enable_debug = value;
#line 59 "../src/client/application/application-configuration.vala"
		g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_ENABLE_DEBUG_PROPERTY]);
#line 275 "application-configuration.c"
	}
}

gboolean
application_configuration_get_enable_inspector (ApplicationConfiguration* self)
{
	gboolean result;
#line 62 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 62 "../src/client/application/application-configuration.vala"
	result = self->priv->_enable_inspector;
#line 62 "../src/client/application/application-configuration.vala"
	return result;
#line 289 "application-configuration.c"
}

void
application_configuration_set_enable_inspector (ApplicationConfiguration* self,
                                                gboolean value)
{
	gboolean old_value;
#line 62 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 62 "../src/client/application/application-configuration.vala"
	old_value = application_configuration_get_enable_inspector (self);
#line 62 "../src/client/application/application-configuration.vala"
	if (old_value != value) {
#line 62 "../src/client/application/application-configuration.vala"
		self->priv->_enable_inspector = value;
#line 62 "../src/client/application/application-configuration.vala"
		g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_ENABLE_INSPECTOR_PROPERTY]);
#line 307 "application-configuration.c"
	}
}

gboolean
application_configuration_get_revoke_certs (ApplicationConfiguration* self)
{
	gboolean result;
#line 65 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 65 "../src/client/application/application-configuration.vala"
	result = self->priv->_revoke_certs;
#line 65 "../src/client/application/application-configuration.vala"
	return result;
#line 321 "application-configuration.c"
}

void
application_configuration_set_revoke_certs (ApplicationConfiguration* self,
                                            gboolean value)
{
	gboolean old_value;
#line 65 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 65 "../src/client/application/application-configuration.vala"
	old_value = application_configuration_get_revoke_certs (self);
#line 65 "../src/client/application/application-configuration.vala"
	if (old_value != value) {
#line 65 "../src/client/application/application-configuration.vala"
		self->priv->_revoke_certs = value;
#line 65 "../src/client/application/application-configuration.vala"
		g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_REVOKE_CERTS_PROPERTY]);
#line 339 "application-configuration.c"
	}
}

ApplicationConfigurationDesktopEnvironment
application_configuration_get_desktop_environment (ApplicationConfiguration* self)
{
	ApplicationConfigurationDesktopEnvironment result;
	gchar* xdg_current_desktop = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 68 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0);
#line 69 "../src/client/application/application-configuration.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 69 "../src/client/application/application-configuration.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 69 "../src/client/application/application-configuration.vala"
	xdg_current_desktop = _tmp1_;
#line 70 "../src/client/application/application-configuration.vala"
	_tmp3_ = xdg_current_desktop;
#line 70 "../src/client/application/application-configuration.vala"
	if (_tmp3_ != NULL) {
#line 364 "application-configuration.c"
		const gchar* _tmp4_;
#line 70 "../src/client/application/application-configuration.vala"
		_tmp4_ = xdg_current_desktop;
#line 70 "../src/client/application/application-configuration.vala"
		_tmp2_ = g_str_has_prefix (_tmp4_, "Unity");
#line 370 "application-configuration.c"
	} else {
#line 70 "../src/client/application/application-configuration.vala"
		_tmp2_ = FALSE;
#line 374 "application-configuration.c"
	}
#line 70 "../src/client/application/application-configuration.vala"
	if (_tmp2_) {
#line 71 "../src/client/application/application-configuration.vala"
		result = APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY;
#line 71 "../src/client/application/application-configuration.vala"
		_g_free0 (xdg_current_desktop);
#line 71 "../src/client/application/application-configuration.vala"
		return result;
#line 384 "application-configuration.c"
	} else {
#line 73 "../src/client/application/application-configuration.vala"
		result = APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN;
#line 73 "../src/client/application/application-configuration.vala"
		_g_free0 (xdg_current_desktop);
#line 73 "../src/client/application/application-configuration.vala"
		return result;
#line 392 "application-configuration.c"
	}
}

gint
application_configuration_get_window_width (ApplicationConfiguration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 79 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0);
#line 79 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 79 "../src/client/application/application-configuration.vala"
	result = g_settings_get_int (_tmp0_, APPLICATION_CONFIGURATION_WINDOW_WIDTH_KEY);
#line 79 "../src/client/application/application-configuration.vala"
	return result;
#line 409 "application-configuration.c"
}

gint
application_configuration_get_window_height (ApplicationConfiguration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 83 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0);
#line 83 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 83 "../src/client/application/application-configuration.vala"
	result = g_settings_get_int (_tmp0_, APPLICATION_CONFIGURATION_WINDOW_HEIGHT_KEY);
#line 83 "../src/client/application/application-configuration.vala"
	return result;
#line 425 "application-configuration.c"
}

gboolean
application_configuration_get_window_maximize (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 87 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 87 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 87 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_WINDOW_MAXIMIZE_KEY);
#line 87 "../src/client/application/application-configuration.vala"
	return result;
#line 441 "application-configuration.c"
}

gboolean
application_configuration_get_formatting_toolbar_visible (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 91 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 91 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 91 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE);
#line 91 "../src/client/application/application-configuration.vala"
	return result;
#line 457 "application-configuration.c"
}

void
application_configuration_set_formatting_toolbar_visible (ApplicationConfiguration* self,
                                                          gboolean value)
{
	GSettings* _tmp0_;
#line 92 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 92 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 92 "../src/client/application/application-configuration.vala"
	g_settings_set_boolean (_tmp0_, APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE, value);
#line 92 "../src/client/application/application-configuration.vala"
	g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE_PROPERTY]);
#line 473 "application-configuration.c"
}

gboolean
application_configuration_get_autoselect (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 96 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 96 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 96 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_AUTOSELECT_KEY);
#line 96 "../src/client/application/application-configuration.vala"
	return result;
#line 489 "application-configuration.c"
}

gboolean
application_configuration_get_display_preview (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 100 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 100 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 100 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_DISPLAY_PREVIEW_KEY);
#line 100 "../src/client/application/application-configuration.vala"
	return result;
#line 505 "application-configuration.c"
}

gboolean
application_configuration_get_unset_html_colors (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 104 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 104 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 104 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_UNSET_HTML_COLORS);
#line 104 "../src/client/application/application-configuration.vala"
	return result;
#line 521 "application-configuration.c"
}

gboolean
application_configuration_get_single_key_shortcuts (ApplicationConfiguration* self)
{
	gboolean result;
#line 107 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 107 "../src/client/application/application-configuration.vala"
	result = self->priv->_single_key_shortcuts;
#line 107 "../src/client/application/application-configuration.vala"
	return result;
#line 534 "application-configuration.c"
}

void
application_configuration_set_single_key_shortcuts (ApplicationConfiguration* self,
                                                    gboolean value)
{
	gboolean old_value;
#line 107 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 107 "../src/client/application/application-configuration.vala"
	old_value = application_configuration_get_single_key_shortcuts (self);
#line 107 "../src/client/application/application-configuration.vala"
	if (old_value != value) {
#line 107 "../src/client/application/application-configuration.vala"
		self->priv->_single_key_shortcuts = value;
#line 107 "../src/client/application/application-configuration.vala"
		g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS_PROPERTY]);
#line 552 "application-configuration.c"
	}
}

gboolean
application_configuration_get_run_in_background (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 110 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 110 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 110 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_KEY);
#line 110 "../src/client/application/application-configuration.vala"
	return result;
#line 569 "application-configuration.c"
}

void
application_configuration_set_run_in_background (ApplicationConfiguration* self,
                                                 gboolean value)
{
#line 111 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 111 "../src/client/application/application-configuration.vala"
	application_configuration_set_boolean (self, APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_KEY, value);
#line 111 "../src/client/application/application-configuration.vala"
	g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_PROPERTY]);
#line 582 "application-configuration.c"
}

UtilDateClockFormat
application_configuration_get_clock_format (ApplicationConfiguration* self)
{
	UtilDateClockFormat result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 116 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0);
#line 117 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_gnome_interface;
#line 117 "../src/client/application/application-configuration.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, APPLICATION_CONFIGURATION_CLOCK_FORMAT_KEY);
#line 117 "../src/client/application/application-configuration.vala"
	_tmp2_ = _tmp1_;
#line 117 "../src/client/application/application-configuration.vala"
	_tmp3_ = g_strcmp0 (_tmp2_, "12h") == 0;
#line 117 "../src/client/application/application-configuration.vala"
	_g_free0 (_tmp2_);
#line 117 "../src/client/application/application-configuration.vala"
	if (_tmp3_) {
#line 118 "../src/client/application/application-configuration.vala"
		result = UTIL_DATE_CLOCK_FORMAT_TWELVE_HOURS;
#line 118 "../src/client/application/application-configuration.vala"
		return result;
#line 611 "application-configuration.c"
	} else {
#line 120 "../src/client/application/application-configuration.vala"
		result = UTIL_DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS;
#line 120 "../src/client/application/application-configuration.vala"
		return result;
#line 617 "application-configuration.c"
	}
}

gboolean
application_configuration_get_ask_open_attachment (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 125 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 125 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 125 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY);
#line 125 "../src/client/application/application-configuration.vala"
	return result;
#line 634 "application-configuration.c"
}

void
application_configuration_set_ask_open_attachment (ApplicationConfiguration* self,
                                                   gboolean value)
{
#line 126 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 126 "../src/client/application/application-configuration.vala"
	application_configuration_set_boolean (self, APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY, value);
#line 126 "../src/client/application/application-configuration.vala"
	g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_PROPERTY]);
#line 647 "application-configuration.c"
}

gboolean
application_configuration_get_compose_as_html (ApplicationConfiguration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 130 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), FALSE);
#line 130 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 130 "../src/client/application/application-configuration.vala"
	result = g_settings_get_boolean (_tmp0_, APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_KEY);
#line 130 "../src/client/application/application-configuration.vala"
	return result;
#line 663 "application-configuration.c"
}

void
application_configuration_set_compose_as_html (ApplicationConfiguration* self,
                                               gboolean value)
{
#line 131 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 131 "../src/client/application/application-configuration.vala"
	application_configuration_set_boolean (self, APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_KEY, value);
#line 131 "../src/client/application/application-configuration.vala"
	g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_PROPERTY]);
#line 676 "application-configuration.c"
}

gdouble
application_configuration_get_conversation_viewer_zoom (ApplicationConfiguration* self)
{
	gdouble result;
	GSettings* _tmp0_;
#line 135 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0.0);
#line 135 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 135 "../src/client/application/application-configuration.vala"
	result = g_settings_get_double (_tmp0_, APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY);
#line 135 "../src/client/application/application-configuration.vala"
	return result;
#line 692 "application-configuration.c"
}

void
application_configuration_set_conversation_viewer_zoom (ApplicationConfiguration* self,
                                                        gdouble value)
{
	GSettings* _tmp0_;
#line 136 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 136 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 136 "../src/client/application/application-configuration.vala"
	g_settings_set_double (_tmp0_, APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY, value);
#line 136 "../src/client/application/application-configuration.vala"
	g_object_notify_by_pspec ((GObject *) self, application_configuration_properties[APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_PROPERTY]);
#line 708 "application-configuration.c"
}

gint
application_configuration_get_undo_send_delay (ApplicationConfiguration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 141 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0);
#line 141 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 141 "../src/client/application/application-configuration.vala"
	result = g_settings_get_int (_tmp0_, APPLICATION_CONFIGURATION_UNDO_SEND_DELAY);
#line 141 "../src/client/application/application-configuration.vala"
	return result;
#line 724 "application-configuration.c"
}

gint
application_configuration_get_brief_notification_duration (ApplicationConfiguration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 146 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0);
#line 146 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 146 "../src/client/application/application-configuration.vala"
	result = g_settings_get_int (_tmp0_, APPLICATION_CONFIGURATION_BRIEF_NOTIFICATION_DURATION);
#line 146 "../src/client/application/application-configuration.vala"
	return result;
#line 740 "application-configuration.c"
}

ApplicationConfiguration*
application_configuration_construct (GType object_type,
                                     const gchar* schema_id)
{
	ApplicationConfiguration * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
#line 150 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (schema_id != NULL, NULL);
#line 150 "../src/client/application/application-configuration.vala"
	self = (ApplicationConfiguration*) geary_base_object_construct (object_type);
#line 152 "../src/client/application/application-configuration.vala"
	_tmp0_ = g_settings_new (schema_id);
#line 152 "../src/client/application/application-configuration.vala"
	_tmp1_ = _tmp0_;
#line 152 "../src/client/application/application-configuration.vala"
	application_configuration_set_settings (self, _tmp1_);
#line 152 "../src/client/application/application-configuration.vala"
	_g_object_unref0 (_tmp1_);
#line 153 "../src/client/application/application-configuration.vala"
	_tmp2_ = g_settings_new ("org.gnome.desktop.interface");
#line 153 "../src/client/application/application-configuration.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/client/application/application-configuration.vala"
	application_configuration_set_gnome_interface (self, _tmp3_);
#line 153 "../src/client/application/application-configuration.vala"
	_g_object_unref0 (_tmp3_);
#line 155 "../src/client/application/application-configuration.vala"
	_tmp4_ = self->priv->_settings;
#line 155 "../src/client/application/application-configuration.vala"
	util_migrate_old_app_config (_tmp4_, UTIL_MIGRATE_OLD_APP_ID);
#line 157 "../src/client/application/application-configuration.vala"
	application_configuration_bind (self, APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS, G_SETTINGS_BIND_DEFAULT);
#line 150 "../src/client/application/application-configuration.vala"
	return self;
#line 781 "application-configuration.c"
}

ApplicationConfiguration*
application_configuration_new (const gchar* schema_id)
{
#line 150 "../src/client/application/application-configuration.vala"
	return application_configuration_construct (APPLICATION_TYPE_CONFIGURATION, schema_id);
#line 789 "application-configuration.c"
}

void
application_configuration_bind (ApplicationConfiguration* self,
                                const gchar* key,
                                GObject* object,
                                const gchar* property,
                                GSettingsBindFlags flags)
{
	GSettings* _tmp0_;
#line 160 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 160 "../src/client/application/application-configuration.vala"
	g_return_if_fail (key != NULL);
#line 160 "../src/client/application/application-configuration.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT));
#line 160 "../src/client/application/application-configuration.vala"
	g_return_if_fail (property != NULL);
#line 162 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 162 "../src/client/application/application-configuration.vala"
	g_settings_bind (_tmp0_, key, object, property, flags);
#line 812 "application-configuration.c"
}

void
application_configuration_bind_with_mapping (ApplicationConfiguration* self,
                                             const gchar* key,
                                             GObject* object,
                                             const gchar* property,
                                             GSettingsBindGetMapping get_mapping,
                                             GSettingsBindSetMapping set_mapping,
                                             GSettingsBindFlags flags)
{
	GSettings* _tmp0_;
#line 165 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 165 "../src/client/application/application-configuration.vala"
	g_return_if_fail (key != NULL);
#line 165 "../src/client/application/application-configuration.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT));
#line 165 "../src/client/application/application-configuration.vala"
	g_return_if_fail (property != NULL);
#line 169 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 169 "../src/client/application/application-configuration.vala"
	g_settings_bind_with_mapping (_tmp0_, key, object, property, flags, get_mapping, set_mapping, NULL, NULL);
#line 837 "application-configuration.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 846 "application-configuration.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 854 "application-configuration.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 863 "application-configuration.c"
	}
}

static void
application_configuration_set_boolean (ApplicationConfiguration* self,
                                       const gchar* name,
                                       gboolean value)
{
	GSettings* _tmp0_;
#line 175 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 175 "../src/client/application/application-configuration.vala"
	g_return_if_fail (name != NULL);
#line 176 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 176 "../src/client/application/application-configuration.vala"
	if (!g_settings_set_boolean (_tmp0_, name, value)) {
#line 881 "application-configuration.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 177 "../src/client/application/application-configuration.vala"
		_tmp1_ = bool_to_string (value);
#line 177 "../src/client/application/application-configuration.vala"
		_tmp2_ = _tmp1_;
#line 177 "../src/client/application/application-configuration.vala"
		g_message ("application-configuration.vala:177: Unable to set configuration value " \
"%s = %s", name, _tmp2_);
#line 177 "../src/client/application/application-configuration.vala"
		_g_free0 (_tmp2_);
#line 892 "application-configuration.c"
	}
}

/** Returns the saved size of the composer window. */
static gint
_variant_get1 (GVariant* value)
{
#line 185 "../src/client/application/application-configuration.vala"
	return g_variant_get_int32 (value);
#line 902 "application-configuration.c"
}

static gint
_variant_get2 (GVariant* value)
{
#line 185 "../src/client/application/application-configuration.vala"
	return g_variant_get_int32 (value);
#line 910 "application-configuration.c"
}

gint*
application_configuration_get_composer_window_size (ApplicationConfiguration* self,
                                                    gint* result_length1)
{
	gint* size = NULL;
	gint* _tmp0_;
	gint size_length1;
	gint _size_size_;
	GVariant* s = NULL;
	GSettings* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gint* _tmp14_;
	gint _tmp14__length1;
	gint* result;
#line 181 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), NULL);
#line 182 "../src/client/application/application-configuration.vala"
	_tmp0_ = g_new0 (gint, 2);
#line 182 "../src/client/application/application-configuration.vala"
	size = _tmp0_;
#line 182 "../src/client/application/application-configuration.vala"
	size_length1 = 2;
#line 182 "../src/client/application/application-configuration.vala"
	_size_size_ = size_length1;
#line 183 "../src/client/application/application-configuration.vala"
	_tmp1_ = self->priv->_settings;
#line 183 "../src/client/application/application-configuration.vala"
	_tmp2_ = g_settings_get_value (_tmp1_, APPLICATION_CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY);
#line 183 "../src/client/application/application-configuration.vala"
	s = _tmp2_;
#line 184 "../src/client/application/application-configuration.vala"
	_tmp3_ = s;
#line 184 "../src/client/application/application-configuration.vala"
	if (g_variant_n_children (_tmp3_) == ((gsize) 2)) {
#line 948 "application-configuration.c"
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		gint _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
		gint _tmp11_;
		gint* _tmp12_;
#line 185 "../src/client/application/application-configuration.vala"
		_tmp4_ = s;
#line 185 "../src/client/application/application-configuration.vala"
		_tmp5_ = g_variant_get_child_value (_tmp4_, (gsize) 0);
#line 185 "../src/client/application/application-configuration.vala"
		_tmp6_ = _tmp5_;
#line 185 "../src/client/application/application-configuration.vala"
		_tmp7_ = _variant_get1 (_tmp6_);
#line 185 "../src/client/application/application-configuration.vala"
		_tmp8_ = s;
#line 185 "../src/client/application/application-configuration.vala"
		_tmp9_ = g_variant_get_child_value (_tmp8_, (gsize) 1);
#line 185 "../src/client/application/application-configuration.vala"
		_tmp10_ = _tmp9_;
#line 185 "../src/client/application/application-configuration.vala"
		_tmp11_ = _variant_get2 (_tmp10_);
#line 185 "../src/client/application/application-configuration.vala"
		_tmp12_ = g_new0 (gint, 2);
#line 185 "../src/client/application/application-configuration.vala"
		_tmp12_[0] = _tmp7_;
#line 185 "../src/client/application/application-configuration.vala"
		_tmp12_[1] = _tmp11_;
#line 185 "../src/client/application/application-configuration.vala"
		size = (g_free (size), NULL);
#line 185 "../src/client/application/application-configuration.vala"
		size = _tmp12_;
#line 185 "../src/client/application/application-configuration.vala"
		size_length1 = 2;
#line 185 "../src/client/application/application-configuration.vala"
		_size_size_ = size_length1;
#line 185 "../src/client/application/application-configuration.vala"
		_g_variant_unref0 (_tmp10_);
#line 185 "../src/client/application/application-configuration.vala"
		_g_variant_unref0 (_tmp6_);
#line 992 "application-configuration.c"
	} else {
		gint* _tmp13_;
#line 187 "../src/client/application/application-configuration.vala"
		_tmp13_ = g_new0 (gint, 2);
#line 187 "../src/client/application/application-configuration.vala"
		_tmp13_[0] = -1;
#line 187 "../src/client/application/application-configuration.vala"
		_tmp13_[1] = -1;
#line 187 "../src/client/application/application-configuration.vala"
		size = (g_free (size), NULL);
#line 187 "../src/client/application/application-configuration.vala"
		size = _tmp13_;
#line 187 "../src/client/application/application-configuration.vala"
		size_length1 = 2;
#line 187 "../src/client/application/application-configuration.vala"
		_size_size_ = size_length1;
#line 1009 "application-configuration.c"
	}
#line 189 "../src/client/application/application-configuration.vala"
	_tmp14_ = size;
#line 189 "../src/client/application/application-configuration.vala"
	_tmp14__length1 = size_length1;
#line 189 "../src/client/application/application-configuration.vala"
	if (result_length1) {
#line 189 "../src/client/application/application-configuration.vala"
		*result_length1 = _tmp14__length1;
#line 1019 "application-configuration.c"
	}
#line 189 "../src/client/application/application-configuration.vala"
	result = _tmp14_;
#line 189 "../src/client/application/application-configuration.vala"
	_g_variant_unref0 (s);
#line 189 "../src/client/application/application-configuration.vala"
	return result;
#line 1027 "application-configuration.c"
}

/** Sets the saved size of the composer window. */
static GVariant*
_variant_new1 (gint* value,
               gint value_length1)
{
	gint* _tmp1_;
	GVariantBuilder _tmp2_;
	gint _tmp3_;
#line 194 "../src/client/application/application-configuration.vala"
	_tmp1_ = value;
#line 194 "../src/client/application/application-configuration.vala"
	g_variant_builder_init (&_tmp2_, G_VARIANT_TYPE ("ai"));
#line 194 "../src/client/application/application-configuration.vala"
	for (_tmp3_ = 0; _tmp3_ < value_length1; _tmp3_++) {
#line 194 "../src/client/application/application-configuration.vala"
		g_variant_builder_add_value (&_tmp2_, g_variant_new_int32 (*_tmp1_));
#line 194 "../src/client/application/application-configuration.vala"
		_tmp1_++;
#line 1048 "application-configuration.c"
	}
#line 194 "../src/client/application/application-configuration.vala"
	return g_variant_ref_sink (g_variant_builder_end (&_tmp2_));
#line 1052 "application-configuration.c"
}

void
application_configuration_set_composer_window_size (ApplicationConfiguration* self,
                                                    gint* value,
                                                    gint value_length1)
{
	GSettings* _tmp0_;
	GVariant* _tmp4_;
#line 193 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 194 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 194 "../src/client/application/application-configuration.vala"
	_tmp4_ = _variant_new1 (value, value_length1);
#line 194 "../src/client/application/application-configuration.vala"
	g_settings_set_value (_tmp0_, APPLICATION_CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY, _tmp4_);
#line 194 "../src/client/application/application-configuration.vala"
	_g_variant_unref0 (_tmp4_);
#line 1072 "application-configuration.c"
}

/** Returns list of trusted domains for which images loading is allowed. */
gchar**
application_configuration_get_images_trusted_domains (ApplicationConfiguration* self,
                                                      gint* result_length1)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** result;
#line 198 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), NULL);
#line 199 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 199 "../src/client/application/application-configuration.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, APPLICATION_CONFIGURATION_IMAGES_TRUSTED_DOMAINS);
#line 199 "../src/client/application/application-configuration.vala"
	_tmp3_ = _tmp2_;
#line 199 "../src/client/application/application-configuration.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 199 "../src/client/application/application-configuration.vala"
	if (result_length1) {
#line 199 "../src/client/application/application-configuration.vala"
		*result_length1 = _tmp3__length1;
#line 1100 "application-configuration.c"
	}
#line 199 "../src/client/application/application-configuration.vala"
	result = _tmp3_;
#line 199 "../src/client/application/application-configuration.vala"
	return result;
#line 1106 "application-configuration.c"
}

/** Sets list of trusted domains for which images loading is allowed. */
void
application_configuration_set_images_trusted_domains (ApplicationConfiguration* self,
                                                      gchar** value,
                                                      gint value_length1)
{
	GSettings* _tmp0_;
#line 203 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 204 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 204 "../src/client/application/application-configuration.vala"
	g_settings_set_strv (_tmp0_, APPLICATION_CONFIGURATION_IMAGES_TRUSTED_DOMAINS, value);
#line 1122 "application-configuration.c"
}

/** Adds domain to trusted list for which images loading is allowed. */
static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 210 "../src/client/application/application-configuration.vala"
	if ((*length) == (*size)) {
#line 210 "../src/client/application/application-configuration.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 210 "../src/client/application/application-configuration.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1138 "application-configuration.c"
	}
#line 210 "../src/client/application/application-configuration.vala"
	(*array)[(*length)++] = value;
#line 210 "../src/client/application/application-configuration.vala"
	(*array)[*length] = NULL;
#line 1144 "application-configuration.c"
}

void
application_configuration_add_images_trusted_domain (ApplicationConfiguration* self,
                                                     const gchar* domain)
{
	gchar** domains = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint domains_length1;
	gint _domains_size_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 208 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 208 "../src/client/application/application-configuration.vala"
	g_return_if_fail (domain != NULL);
#line 209 "../src/client/application/application-configuration.vala"
	_tmp1_ = application_configuration_get_images_trusted_domains (self, &_tmp0_);
#line 209 "../src/client/application/application-configuration.vala"
	domains = _tmp1_;
#line 209 "../src/client/application/application-configuration.vala"
	domains_length1 = _tmp0_;
#line 209 "../src/client/application/application-configuration.vala"
	_domains_size_ = domains_length1;
#line 210 "../src/client/application/application-configuration.vala"
	_tmp2_ = g_strdup (domain);
#line 210 "../src/client/application/application-configuration.vala"
	_vala_array_add5 (&domains, &domains_length1, &_domains_size_, _tmp2_);
#line 211 "../src/client/application/application-configuration.vala"
	_tmp3_ = domains;
#line 211 "../src/client/application/application-configuration.vala"
	_tmp3__length1 = domains_length1;
#line 211 "../src/client/application/application-configuration.vala"
	application_configuration_set_images_trusted_domains (self, _tmp3_, (gint) _tmp3__length1);
#line 208 "../src/client/application/application-configuration.vala"
	domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 1183 "application-configuration.c"
}

/** Removes domain from trusted for which images loading is allowed. */
static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 220 "../src/client/application/application-configuration.vala"
	if ((*length) == (*size)) {
#line 220 "../src/client/application/application-configuration.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 220 "../src/client/application/application-configuration.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1199 "application-configuration.c"
	}
#line 220 "../src/client/application/application-configuration.vala"
	(*array)[(*length)++] = value;
#line 220 "../src/client/application/application-configuration.vala"
	(*array)[*length] = NULL;
#line 1205 "application-configuration.c"
}

void
application_configuration_remove_images_trusted_domain (ApplicationConfiguration* self,
                                                        const gchar* domain)
{
	gchar** domains = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint domains_length1;
	gint _domains_size_;
	gchar** new_domains = NULL;
	gchar** _tmp2_;
	gint new_domains_length1;
	gint _new_domains_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 215 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 215 "../src/client/application/application-configuration.vala"
	g_return_if_fail (domain != NULL);
#line 216 "../src/client/application/application-configuration.vala"
	_tmp1_ = application_configuration_get_images_trusted_domains (self, &_tmp0_);
#line 216 "../src/client/application/application-configuration.vala"
	domains = _tmp1_;
#line 216 "../src/client/application/application-configuration.vala"
	domains_length1 = _tmp0_;
#line 216 "../src/client/application/application-configuration.vala"
	_domains_size_ = domains_length1;
#line 217 "../src/client/application/application-configuration.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 217 "../src/client/application/application-configuration.vala"
	new_domains = _tmp2_;
#line 217 "../src/client/application/application-configuration.vala"
	new_domains_length1 = 0;
#line 217 "../src/client/application/application-configuration.vala"
	_new_domains_size_ = new_domains_length1;
#line 218 "../src/client/application/application-configuration.vala"
	_tmp3_ = domains;
#line 218 "../src/client/application/application-configuration.vala"
	_tmp3__length1 = domains_length1;
#line 1249 "application-configuration.c"
	{
		gchar** _domain_collection = NULL;
		gint _domain_collection_length1 = 0;
		gint __domain_collection_size_ = 0;
		gint _domain_it = 0;
#line 218 "../src/client/application/application-configuration.vala"
		_domain_collection = _tmp3_;
#line 218 "../src/client/application/application-configuration.vala"
		_domain_collection_length1 = _tmp3__length1;
#line 218 "../src/client/application/application-configuration.vala"
		for (_domain_it = 0; _domain_it < _domain_collection_length1; _domain_it = _domain_it + 1) {
#line 1261 "application-configuration.c"
			gchar* _tmp4_;
			gchar* _domain = NULL;
#line 218 "../src/client/application/application-configuration.vala"
			_tmp4_ = g_strdup (_domain_collection[_domain_it]);
#line 218 "../src/client/application/application-configuration.vala"
			_domain = _tmp4_;
#line 1268 "application-configuration.c"
			{
				const gchar* _tmp5_;
#line 219 "../src/client/application/application-configuration.vala"
				_tmp5_ = _domain;
#line 219 "../src/client/application/application-configuration.vala"
				if (g_strcmp0 (domain, _tmp5_) != 0) {
#line 1275 "application-configuration.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 220 "../src/client/application/application-configuration.vala"
					_tmp6_ = _domain;
#line 220 "../src/client/application/application-configuration.vala"
					_tmp7_ = g_strdup (_tmp6_);
#line 220 "../src/client/application/application-configuration.vala"
					_vala_array_add6 (&new_domains, &new_domains_length1, &_new_domains_size_, _tmp7_);
#line 1284 "application-configuration.c"
				}
#line 218 "../src/client/application/application-configuration.vala"
				_g_free0 (_domain);
#line 1288 "application-configuration.c"
			}
		}
	}
#line 222 "../src/client/application/application-configuration.vala"
	_tmp8_ = new_domains;
#line 222 "../src/client/application/application-configuration.vala"
	_tmp8__length1 = new_domains_length1;
#line 222 "../src/client/application/application-configuration.vala"
	application_configuration_set_images_trusted_domains (self, _tmp8_, (gint) _tmp8__length1);
#line 215 "../src/client/application/application-configuration.vala"
	new_domains = (_vala_array_free (new_domains, new_domains_length1, (GDestroyNotify) g_free), NULL);
#line 215 "../src/client/application/application-configuration.vala"
	domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 1302 "application-configuration.c"
}

/**
     * Returns list of optional plugins to load by default
     */
gchar**
application_configuration_get_optional_plugins (ApplicationConfiguration* self,
                                                gint* result_length1)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** result;
#line 228 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), NULL);
#line 229 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 229 "../src/client/application/application-configuration.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, APPLICATION_CONFIGURATION_OPTIONAL_PLUGINS);
#line 229 "../src/client/application/application-configuration.vala"
	_tmp3_ = _tmp2_;
#line 229 "../src/client/application/application-configuration.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 229 "../src/client/application/application-configuration.vala"
	if (result_length1) {
#line 229 "../src/client/application/application-configuration.vala"
		*result_length1 = _tmp3__length1;
#line 1332 "application-configuration.c"
	}
#line 229 "../src/client/application/application-configuration.vala"
	result = _tmp3_;
#line 229 "../src/client/application/application-configuration.vala"
	return result;
#line 1338 "application-configuration.c"
}

/**
     * Sets the list of optional plugins to load by default
     */
void
application_configuration_set_optional_plugins (ApplicationConfiguration* self,
                                                gchar** value,
                                                gint value_length1)
{
	GSettings* _tmp0_;
#line 235 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 236 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 236 "../src/client/application/application-configuration.vala"
	g_settings_set_strv (_tmp0_, APPLICATION_CONFIGURATION_OPTIONAL_PLUGINS, value);
#line 1356 "application-configuration.c"
}

/**
     * Returns enabled spell checker languages.
     *
     * This specifies the languages used for spell checking by the
     * client. By default, the set will contain languages based on
     * environment variables.
     *
     * @see Util.I18n.get_user_preferred_languages
     */
static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 252 "../src/client/application/application-configuration.vala"
	if (length >= 0) {
#line 1374 "application-configuration.c"
		gchar** result;
		gssize i;
#line 252 "../src/client/application/application-configuration.vala"
		result = g_new0 (gchar*, length + 1);
#line 252 "../src/client/application/application-configuration.vala"
		for (i = 0; i < length; i++) {
#line 1381 "application-configuration.c"
			gchar* _tmp0_;
#line 252 "../src/client/application/application-configuration.vala"
			_tmp0_ = g_strdup (self[i]);
#line 252 "../src/client/application/application-configuration.vala"
			result[i] = _tmp0_;
#line 1387 "application-configuration.c"
		}
#line 252 "../src/client/application/application-configuration.vala"
		return result;
#line 1391 "application-configuration.c"
	}
#line 252 "../src/client/application/application-configuration.vala"
	return NULL;
#line 1395 "application-configuration.c"
}

gchar**
application_configuration_get_spell_check_languages (ApplicationConfiguration* self,
                                                     gint* result_length1)
{
	GVariant* value = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	const gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint __tmp5__size_ = 0;
	GVariant* _tmp6_;
	gchar** langs = NULL;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint langs_length1;
	gint _langs_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** result;
#line 248 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), NULL);
#line 249 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 249 "../src/client/application/application-configuration.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, APPLICATION_CONFIGURATION_SPELL_CHECK_LANGUAGES);
#line 249 "../src/client/application/application-configuration.vala"
	_tmp2_ = _tmp1_;
#line 249 "../src/client/application/application-configuration.vala"
	_tmp3_ = g_variant_get_maybe (_tmp2_);
#line 249 "../src/client/application/application-configuration.vala"
	_tmp4_ = _tmp3_;
#line 249 "../src/client/application/application-configuration.vala"
	_g_variant_unref0 (_tmp2_);
#line 249 "../src/client/application/application-configuration.vala"
	value = _tmp4_;
#line 252 "../src/client/application/application-configuration.vala"
	_tmp6_ = value;
#line 252 "../src/client/application/application-configuration.vala"
	if (_tmp6_ != NULL) {
#line 1440 "application-configuration.c"
		GVariant* _tmp7_;
		gsize _tmp8_ = 0;
		const gchar** _tmp9_;
#line 253 "../src/client/application/application-configuration.vala"
		_tmp7_ = value;
#line 253 "../src/client/application/application-configuration.vala"
		_tmp9_ = g_variant_get_strv (_tmp7_, &_tmp8_);
#line 253 "../src/client/application/application-configuration.vala"
		_tmp5_ = (g_free (_tmp5_), NULL);
#line 253 "../src/client/application/application-configuration.vala"
		_tmp5_ = _tmp9_;
#line 253 "../src/client/application/application-configuration.vala"
		_tmp5__length1 = _tmp8_;
#line 253 "../src/client/application/application-configuration.vala"
		__tmp5__size_ = _tmp5__length1;
#line 1456 "application-configuration.c"
	} else {
		gint _tmp10_ = 0;
		gchar** _tmp11_;
#line 254 "../src/client/application/application-configuration.vala"
		_tmp11_ = util_i18n_get_user_preferred_languages (&_tmp10_);
#line 254 "../src/client/application/application-configuration.vala"
		_tmp5_ = (g_free (_tmp5_), NULL);
#line 254 "../src/client/application/application-configuration.vala"
		_tmp5_ = _tmp11_;
#line 254 "../src/client/application/application-configuration.vala"
		_tmp5__length1 = _tmp10_;
#line 254 "../src/client/application/application-configuration.vala"
		__tmp5__size_ = _tmp5__length1;
#line 1470 "application-configuration.c"
	}
#line 252 "../src/client/application/application-configuration.vala"
	_tmp12_ = (_tmp5_ != NULL) ? _vala_array_dup2 (_tmp5_, _tmp5__length1) : _tmp5_;
#line 252 "../src/client/application/application-configuration.vala"
	_tmp12__length1 = _tmp5__length1;
#line 252 "../src/client/application/application-configuration.vala"
	langs = _tmp12_;
#line 252 "../src/client/application/application-configuration.vala"
	langs_length1 = _tmp12__length1;
#line 252 "../src/client/application/application-configuration.vala"
	_langs_size_ = langs_length1;
#line 255 "../src/client/application/application-configuration.vala"
	_tmp13_ = langs;
#line 255 "../src/client/application/application-configuration.vala"
	_tmp13__length1 = langs_length1;
#line 255 "../src/client/application/application-configuration.vala"
	if (result_length1) {
#line 255 "../src/client/application/application-configuration.vala"
		*result_length1 = _tmp13__length1;
#line 1490 "application-configuration.c"
	}
#line 255 "../src/client/application/application-configuration.vala"
	result = _tmp13_;
#line 255 "../src/client/application/application-configuration.vala"
	_tmp5_ = (g_free (_tmp5_), NULL);
#line 255 "../src/client/application/application-configuration.vala"
	_g_variant_unref0 (value);
#line 255 "../src/client/application/application-configuration.vala"
	return result;
#line 1500 "application-configuration.c"
}

/**
     * Sets enabled spell checker languages.
     *
     * This specifies the languages used for spell checking by the
     * client. By default, the set will contain languages based on
     * environment variables.
     *
     * @see Util.I18n.get_user_preferred_languages
     */
void
application_configuration_set_spell_check_languages (ApplicationConfiguration* self,
                                                     gchar** value,
                                                     gint value_length1)
{
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 267 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 268 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 268 "../src/client/application/application-configuration.vala"
	_tmp1_ = g_variant_new_strv (value, value_length1);
#line 268 "../src/client/application/application-configuration.vala"
	g_variant_ref_sink (_tmp1_);
#line 268 "../src/client/application/application-configuration.vala"
	_tmp2_ = _tmp1_;
#line 268 "../src/client/application/application-configuration.vala"
	_tmp3_ = g_variant_new_maybe (NULL, _tmp2_);
#line 268 "../src/client/application/application-configuration.vala"
	g_variant_ref_sink (_tmp3_);
#line 268 "../src/client/application/application-configuration.vala"
	_tmp4_ = _tmp3_;
#line 268 "../src/client/application/application-configuration.vala"
	g_settings_set_value (_tmp0_, APPLICATION_CONFIGURATION_SPELL_CHECK_LANGUAGES, _tmp4_);
#line 268 "../src/client/application/application-configuration.vala"
	_g_variant_unref0 (_tmp4_);
#line 268 "../src/client/application/application-configuration.vala"
	_g_variant_unref0 (_tmp2_);
#line 1544 "application-configuration.c"
}

/**
     * Returns visible spell checker languages.
     *
     * This is the list of languages shown when selecting languages to
     * be used for spell checking.
     */
gchar**
application_configuration_get_spell_check_visible_languages (ApplicationConfiguration* self,
                                                             gint* result_length1)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** result;
#line 280 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), NULL);
#line 281 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 281 "../src/client/application/application-configuration.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, APPLICATION_CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES);
#line 281 "../src/client/application/application-configuration.vala"
	_tmp3_ = _tmp2_;
#line 281 "../src/client/application/application-configuration.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 281 "../src/client/application/application-configuration.vala"
	if (result_length1) {
#line 281 "../src/client/application/application-configuration.vala"
		*result_length1 = _tmp3__length1;
#line 1577 "application-configuration.c"
	}
#line 281 "../src/client/application/application-configuration.vala"
	result = _tmp3_;
#line 281 "../src/client/application/application-configuration.vala"
	return result;
#line 1583 "application-configuration.c"
}

/**
     * Sets visible spell checker languages.
     *
     * This is the list of languages shown when selecting languages to
     * be used for spell checking.
     */
void
application_configuration_set_spell_check_visible_languages (ApplicationConfiguration* self,
                                                             gchar** value,
                                                             gint value_length1)
{
	GSettings* _tmp0_;
#line 290 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 291 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 291 "../src/client/application/application-configuration.vala"
	g_settings_set_strv (_tmp0_, APPLICATION_CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES, value);
#line 1604 "application-configuration.c"
}

GearySearchQueryStrategy
application_configuration_get_search_strategy (ApplicationConfiguration* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 295 "../src/client/application/application-configuration.vala"
	static GQuark _tmp6_label0 = 0;
#line 295 "../src/client/application/application-configuration.vala"
	static GQuark _tmp6_label1 = 0;
#line 295 "../src/client/application/application-configuration.vala"
	static GQuark _tmp6_label2 = 0;
#line 1623 "application-configuration.c"
	GearySearchQueryStrategy result;
#line 294 "../src/client/application/application-configuration.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (self), 0);
#line 295 "../src/client/application/application-configuration.vala"
	_tmp0_ = self->priv->_settings;
#line 295 "../src/client/application/application-configuration.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, APPLICATION_CONFIGURATION_SEARCH_STRATEGY_KEY);
#line 295 "../src/client/application/application-configuration.vala"
	_tmp2_ = _tmp1_;
#line 295 "../src/client/application/application-configuration.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 295 "../src/client/application/application-configuration.vala"
	_tmp4_ = _tmp3_;
#line 295 "../src/client/application/application-configuration.vala"
	_g_free0 (_tmp2_);
#line 295 "../src/client/application/application-configuration.vala"
	_tmp5_ = _tmp4_;
#line 295 "../src/client/application/application-configuration.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 295 "../src/client/application/application-configuration.vala"
	g_free (_tmp5_);
#line 295 "../src/client/application/application-configuration.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("exact")))) {
#line 295 "../src/client/application/application-configuration.vala"
		switch (0) {
#line 1649 "application-configuration.c"
			default:
			{
#line 297 "../src/client/application/application-configuration.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_EXACT;
#line 297 "../src/client/application/application-configuration.vala"
				return result;
#line 1656 "application-configuration.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("aggressive")))) {
#line 295 "../src/client/application/application-configuration.vala"
		switch (0) {
#line 1662 "application-configuration.c"
			default:
			{
#line 300 "../src/client/application/application-configuration.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE;
#line 300 "../src/client/application/application-configuration.vala"
				return result;
#line 1669 "application-configuration.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("horizon")))) {
#line 295 "../src/client/application/application-configuration.vala"
		switch (0) {
#line 1675 "application-configuration.c"
			default:
			{
#line 303 "../src/client/application/application-configuration.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_HORIZON;
#line 303 "../src/client/application/application-configuration.vala"
				return result;
#line 1682 "application-configuration.c"
			}
		}
	} else {
#line 295 "../src/client/application/application-configuration.vala"
		switch (0) {
#line 1688 "application-configuration.c"
			default:
			{
#line 307 "../src/client/application/application-configuration.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE;
#line 307 "../src/client/application/application-configuration.vala"
				return result;
#line 1695 "application-configuration.c"
			}
		}
	}
}

void
application_configuration_set_search_strategy (ApplicationConfiguration* self,
                                               GearySearchQueryStrategy strategy)
{
#line 311 "../src/client/application/application-configuration.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (self));
#line 312 "../src/client/application/application-configuration.vala"
	switch (strategy) {
#line 312 "../src/client/application/application-configuration.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_EXACT:
#line 1711 "application-configuration.c"
		{
			GSettings* _tmp0_;
#line 314 "../src/client/application/application-configuration.vala"
			_tmp0_ = self->priv->_settings;
#line 314 "../src/client/application/application-configuration.vala"
			g_settings_set_string (_tmp0_, APPLICATION_CONFIGURATION_SEARCH_STRATEGY_KEY, "exact");
#line 315 "../src/client/application/application-configuration.vala"
			break;
#line 1720 "application-configuration.c"
		}
#line 312 "../src/client/application/application-configuration.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE:
#line 1724 "application-configuration.c"
		{
			GSettings* _tmp1_;
#line 318 "../src/client/application/application-configuration.vala"
			_tmp1_ = self->priv->_settings;
#line 318 "../src/client/application/application-configuration.vala"
			g_settings_set_string (_tmp1_, APPLICATION_CONFIGURATION_SEARCH_STRATEGY_KEY, "aggressive");
#line 319 "../src/client/application/application-configuration.vala"
			break;
#line 1733 "application-configuration.c"
		}
#line 312 "../src/client/application/application-configuration.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_HORIZON:
#line 1737 "application-configuration.c"
		{
			GSettings* _tmp2_;
#line 322 "../src/client/application/application-configuration.vala"
			_tmp2_ = self->priv->_settings;
#line 322 "../src/client/application/application-configuration.vala"
			g_settings_set_string (_tmp2_, APPLICATION_CONFIGURATION_SEARCH_STRATEGY_KEY, "horizon");
#line 323 "../src/client/application/application-configuration.vala"
			break;
#line 1746 "application-configuration.c"
		}
		default:
#line 312 "../src/client/application/application-configuration.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE:
#line 1751 "application-configuration.c"
		{
			GSettings* _tmp3_;
#line 327 "../src/client/application/application-configuration.vala"
			_tmp3_ = self->priv->_settings;
#line 327 "../src/client/application/application-configuration.vala"
			g_settings_set_string (_tmp3_, APPLICATION_CONFIGURATION_SEARCH_STRATEGY_KEY, "conservative");
#line 328 "../src/client/application/application-configuration.vala"
			break;
#line 1760 "application-configuration.c"
		}
	}
}

static void
application_configuration_class_init (ApplicationConfigurationClass * klass,
                                      gpointer klass_data)
{
#line 12 "../src/client/application/application-configuration.vala"
	application_configuration_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/client/application/application-configuration.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationConfiguration_private_offset);
#line 12 "../src/client/application/application-configuration.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_configuration_get_property;
#line 12 "../src/client/application/application-configuration.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_configuration_set_property;
#line 12 "../src/client/application/application-configuration.vala"
	G_OBJECT_CLASS (klass)->finalize = application_configuration_finalize;
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_SETTINGS_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_GNOME_INTERFACE_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_GNOME_INTERFACE_PROPERTY] = g_param_spec_object ("gnome-interface", "gnome-interface", "gnome-interface", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_ENABLE_DEBUG_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_ENABLE_DEBUG_PROPERTY] = g_param_spec_boolean ("enable-debug", "enable-debug", "enable-debug", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_ENABLE_INSPECTOR_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_ENABLE_INSPECTOR_PROPERTY] = g_param_spec_boolean ("enable-inspector", "enable-inspector", "enable-inspector", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_REVOKE_CERTS_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_REVOKE_CERTS_PROPERTY] = g_param_spec_boolean ("revoke-certs", "revoke-certs", "revoke-certs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_PROPERTY] = g_param_spec_enum ("desktop-environment", "desktop-environment", "desktop-environment", APPLICATION_CONFIGURATION_TYPE_DESKTOP_ENVIRONMENT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_WINDOW_WIDTH_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_WINDOW_WIDTH_PROPERTY] = g_param_spec_int ("window-width", "window-width", "window-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_WINDOW_HEIGHT_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_WINDOW_HEIGHT_PROPERTY] = g_param_spec_int ("window-height", "window-height", "window-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_WINDOW_MAXIMIZE_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_WINDOW_MAXIMIZE_PROPERTY] = g_param_spec_boolean ("window-maximize", "window-maximize", "window-maximize", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE_PROPERTY] = g_param_spec_boolean ("formatting-toolbar-visible", "formatting-toolbar-visible", "formatting-toolbar-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_AUTOSELECT_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_AUTOSELECT_PROPERTY] = g_param_spec_boolean ("autoselect", "autoselect", "autoselect", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_DISPLAY_PREVIEW_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_DISPLAY_PREVIEW_PROPERTY] = g_param_spec_boolean ("display-preview", "display-preview", "display-preview", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_UNSET_HTML_COLORS_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_UNSET_HTML_COLORS_PROPERTY] = g_param_spec_boolean ("unset-html-colors", "unset-html-colors", "unset-html-colors", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS_PROPERTY] = g_param_spec_boolean ("single-key-shortcuts", "single-key-shortcuts", "single-key-shortcuts", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_PROPERTY] = g_param_spec_boolean ("run-in-background", "run-in-background", "run-in-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_CLOCK_FORMAT_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_CLOCK_FORMAT_PROPERTY] = g_param_spec_enum ("clock-format", "clock-format", "clock-format", UTIL_DATE_TYPE_CLOCK_FORMAT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_PROPERTY] = g_param_spec_boolean ("ask-open-attachment", "ask-open-attachment", "ask-open-attachment", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_PROPERTY] = g_param_spec_boolean ("compose-as-html", "compose-as-html", "compose-as-html", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_PROPERTY] = g_param_spec_double ("conversation-viewer-zoom", "conversation-viewer-zoom", "conversation-viewer-zoom", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1817 "application-configuration.c"
	/** The number of seconds to wait before sending an email. */
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_UNDO_SEND_DELAY_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_UNDO_SEND_DELAY_PROPERTY] = g_param_spec_int ("undo-send-delay", "undo-send-delay", "undo-send-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1821 "application-configuration.c"
	/** The number of seconds for which brief notifications should be displayed. */
#line 12 "../src/client/application/application-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CONFIGURATION_BRIEF_NOTIFICATION_DURATION_PROPERTY, application_configuration_properties[APPLICATION_CONFIGURATION_BRIEF_NOTIFICATION_DURATION_PROPERTY] = g_param_spec_int ("brief-notification-duration", "brief-notification-duration", "brief-notification-duration", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1825 "application-configuration.c"
}

static void
application_configuration_instance_init (ApplicationConfiguration * self,
                                         gpointer klass)
{
#line 12 "../src/client/application/application-configuration.vala"
	self->priv = application_configuration_get_instance_private (self);
#line 59 "../src/client/application/application-configuration.vala"
	self->priv->_enable_debug = FALSE;
#line 62 "../src/client/application/application-configuration.vala"
	self->priv->_enable_inspector = FALSE;
#line 65 "../src/client/application/application-configuration.vala"
	self->priv->_revoke_certs = FALSE;
#line 107 "../src/client/application/application-configuration.vala"
	self->priv->_single_key_shortcuts = FALSE;
#line 1842 "application-configuration.c"
}

static void
application_configuration_finalize (GObject * obj)
{
	ApplicationConfiguration * self;
#line 12 "../src/client/application/application-configuration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_CONFIGURATION, ApplicationConfiguration);
#line 55 "../src/client/application/application-configuration.vala"
	_g_object_unref0 (self->priv->_settings);
#line 56 "../src/client/application/application-configuration.vala"
	_g_object_unref0 (self->priv->_gnome_interface);
#line 12 "../src/client/application/application-configuration.vala"
	G_OBJECT_CLASS (application_configuration_parent_class)->finalize (obj);
#line 1857 "application-configuration.c"
}

/**
 * Provides properties to access application GSettings values.
 */
static GType
application_configuration_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationConfigurationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_configuration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationConfiguration), 0, (GInstanceInitFunc) application_configuration_instance_init, NULL };
	GType application_configuration_type_id;
	application_configuration_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "ApplicationConfiguration", &g_define_type_info, 0);
	ApplicationConfiguration_private_offset = g_type_add_instance_private (application_configuration_type_id, sizeof (ApplicationConfigurationPrivate));
	return application_configuration_type_id;
}

GType
application_configuration_get_type (void)
{
	static volatile gsize application_configuration_type_id__once = 0;
	if (g_once_init_enter (&application_configuration_type_id__once)) {
		GType application_configuration_type_id;
		application_configuration_type_id = application_configuration_get_type_once ();
		g_once_init_leave (&application_configuration_type_id__once, application_configuration_type_id);
	}
	return application_configuration_type_id__once;
}

static void
_vala_application_configuration_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	ApplicationConfiguration * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_CONFIGURATION, ApplicationConfiguration);
#line 12 "../src/client/application/application-configuration.vala"
	switch (property_id) {
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_SETTINGS_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_object (value, application_configuration_get_settings (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_GNOME_INTERFACE_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_object (value, application_configuration_get_gnome_interface (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_ENABLE_DEBUG_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_enable_debug (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_ENABLE_INSPECTOR_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_enable_inspector (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_REVOKE_CERTS_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_revoke_certs (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_enum (value, application_configuration_get_desktop_environment (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_WINDOW_WIDTH_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_int (value, application_configuration_get_window_width (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_WINDOW_HEIGHT_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_int (value, application_configuration_get_window_height (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_WINDOW_MAXIMIZE_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_window_maximize (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_formatting_toolbar_visible (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_AUTOSELECT_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_autoselect (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_DISPLAY_PREVIEW_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_display_preview (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_UNSET_HTML_COLORS_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_unset_html_colors (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_single_key_shortcuts (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_run_in_background (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_CLOCK_FORMAT_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_enum (value, application_configuration_get_clock_format (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_ask_open_attachment (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_boolean (value, application_configuration_get_compose_as_html (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_double (value, application_configuration_get_conversation_viewer_zoom (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_UNDO_SEND_DELAY_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_int (value, application_configuration_get_undo_send_delay (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_BRIEF_NOTIFICATION_DURATION_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		g_value_set_int (value, application_configuration_get_brief_notification_duration (self));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 2021 "application-configuration.c"
		default:
#line 12 "../src/client/application/application-configuration.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 2027 "application-configuration.c"
	}
}

static void
_vala_application_configuration_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	ApplicationConfiguration * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_CONFIGURATION, ApplicationConfiguration);
#line 12 "../src/client/application/application-configuration.vala"
	switch (property_id) {
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_SETTINGS_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_settings (self, g_value_get_object (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_GNOME_INTERFACE_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_gnome_interface (self, g_value_get_object (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_ENABLE_DEBUG_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_enable_debug (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_ENABLE_INSPECTOR_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_enable_inspector (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_REVOKE_CERTS_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_revoke_certs (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_FORMATTING_TOOLBAR_VISIBLE_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_formatting_toolbar_visible (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_single_key_shortcuts (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_RUN_IN_BACKGROUND_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_run_in_background (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_ASK_OPEN_ATTACHMENT_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_ask_open_attachment (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_COMPOSE_AS_HTML_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_compose_as_html (self, g_value_get_boolean (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 12 "../src/client/application/application-configuration.vala"
		case APPLICATION_CONFIGURATION_CONVERSATION_VIEWER_ZOOM_PROPERTY:
#line 12 "../src/client/application/application-configuration.vala"
		application_configuration_set_conversation_viewer_zoom (self, g_value_get_double (value));
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 2107 "application-configuration.c"
		default:
#line 12 "../src/client/application/application-configuration.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/client/application/application-configuration.vala"
		break;
#line 2113 "application-configuration.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

